--[[
	Bagnon
		Displays the player's inventory in a single frame
--]]


--globals

--Locals 

--constants
local MAX_BAGS = 4;
local MAX_SLOTS = 164;
local Old_BagSlotButton_OnEnter, Old_MainBag_OnEnter;

--[[ 
	Loading Functions
--]]

function Bagnon_OnLoad()
	this:RegisterEvent("ADDON_LOADED");
end

--[[
	Event Handler
--]]

function Bagnon_OnEvent(event)
	if ( event == "BAG_CLOSED" ) then
		this:Hide();
	elseif ( event == "BAG_OPEN" ) then
		this:Show();
	elseif ( event == "ADDON_LOADED" and arg1 == "Bagnon") then
		this:UnregisterEvent("ADDON_LOADED");
		Bagnon_Load();
	end
end

function Bagnon_Load()
	BagnonCore_LoadSettings(Bagnon, MAX_SLOTS, Bagnon_AddBags, "Inventory");
	
	Bagnon:RegisterEvent("BAG_CLOSED");
	Bagnon:RegisterEvent("BAG_OPEN");
	
	Bagnon_AddBagHooks();
end

--[[
	Add all usable bag slots to Bagnon and resize
--]]

function Bagnon_AddBags()
	for bag = 0, MAX_BAGS, 1 do
		BagnonCore_AddBag(Bagnon, bag);
	end
end

--[[
	UI Functions
--]]

--OnShow
function Bagnon_OnShow()
	MainMenuBarBackpackButton:SetChecked(1);
	PlaySound("igBackPackOpen");
end

--OnHide
function Bagnon_OnHide()
	MainMenuBarBackpackButton:SetChecked(0);
	PlaySound("igBackPackClose");
end

--[[
	Bag Overrides
--]]

function Bagnon_AddBagHooks()
	Old_BagSlotButton_OnEnter = BagSlotButton_OnEnter;
	BagSlotButton_OnEnter = BagnonBag_OnEnter;
	
	Old_MainBag_OnEnter = MainMenuBarBackpackButton:GetScript("OnEnter");
	MainMenuBarBackpackButton:SetScript("OnEnter", BagnonMainBag_OnEnter);
	MainMenuBarBackpackButton:SetScript("OnLeave", BagnonBag_OnLeave);
	
	local i;
	for i = 0, 3 do
		getglobal("CharacterBag" .. i .. "Slot"):SetScript("OnLeave", BagnonBag_OnLeave);
	end
end


function BagnonBag_OnEnter()
	if(Bagnon:IsShown() ) then
		BagnonCore_HighlightSlots(Bagnon, this:GetID() - 19);
	end
	
	Old_BagSlotButton_OnEnter();
end;

function BagnonMainBag_OnEnter()
	if(Bagnon:IsShown() ) then
		BagnonCore_HighlightSlots(Bagnon, this:GetID());
	end
	Old_MainBag_OnEnter();
end

function BagnonBag_OnLeave()
	GameTooltip:Hide();
	BagnonCore_UnhighlightAll(Bagnon);
end