--[[
	Bagnon Main
		Scripts for the global event handler/loader for Bagnon_Core
--]]

--[[ 
	Loading Functions
--]]

function BagnonMain_OnLoad()
	--Slash handler
	BagnonSlash_Load();
	
	--Rescaling detection
	Infield_AddRescaleAction(BagnonMain_RescaleAll);
	
	--Events
	this:RegisterEvent("ADDON_LOADED");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
end

--[[
	Event Handler
--]]

function BagnonMain_OnEvent(event)
	if ( event == "BAG_UPDATE") then
		if( BagnonCore_IsInventoryBag(arg1) and Bagnon and Bagnon:IsVisible() ) then
			BagnonCore_Update(Bagnon);
		elseif( BagnonCore_IsBankBag(arg1) and Banknon and Banknon:IsVisible() ) then
			BagnonCore_Update(Banknon);
		end		
	elseif ( event == "ITEM_LOCK_CHANGED" or event == "BAG_UPDATE_COOLDOWN" ) then
	
		if(Bagnon and Bagnon:IsVisible() ) then
			BagnonCore_Update(Bagnon);
		end
		
		if(Banknon and Banknon:IsVisible() ) then
			BagnonCore_Update(Banknon)
		end
		
	elseif( event == "BAG_OPENED" and BagnonSets.oneBag) then
		this:UnregisterEvent("BAG_OPENED");
		LoadAddOn("Bagnon");
	elseif( event == "BANKFRAME_OPENED") then
		if(BagnonSets.oneBank) then
			this:UnregisterEvent("BANKFRAME_OPENED");
			LoadAddOn("Banknon");
		else
			BagnonMain_ShowBlizBank();
		end
	elseif( event == "ADDON_LOADED" and arg1 == "Bagnon_Core") then
		this:UnregisterEvent("ADDON_LOADED");
		BagnonMain_Load();
	--the following are tweaks because I read that bag update and item lock changed fire off lots of times when zoning
	elseif(event == "PLAYER_ENTERING_WORLD") then
		this:RegisterEvent("BAG_UPDATE");
		this:RegisterEvent("ITEM_LOCK_CHANGED");
		if(Bagnon and Bagnon:IsVisible() ) then
			BagnonCore_Update(Bagnon);
		end
				
		if(Banknon and Banknon:IsVisible() ) then
			BagnonCore_Update(Banknon)
		end
	elseif(event == "PLAYER_LEAVING_WORLD") then
		this:UnregisterEvent("BAG_UPDATE");
		this:UnregisterEvent("ITEM_LOCK_CHANGED");
	end	
end

function BagnonMain_Load()
	BagnonMain_LoadVariables();
	
	this:RegisterEvent("BAG_UPDATE_COOLDOWN");
	
	--dynamically loading frame stuff
	this:RegisterEvent("BANKFRAME_OPENED");
	this:RegisterEvent("BAG_OPENED");
	
	--unregister the bank frame
	BankFrame:UnregisterEvent("BANKFRAME_CLOSED");
	BankFrame:UnregisterEvent("BANKFRAME_OPENED");
end

function BagnonMain_LoadVariables()
	if(not BagnonSets) then
		BagnonSets = {};
		BagnonSets.oneBag = 1;
		BagnonSets.oneBank = 1;
		
		BagnonMsg(BAGNON_INITIALIZED);
	elseif(BagnonSets.version ~= BAGNON_VERSION) then
		
		BagnonSets.version = BAGNON_VERSION;
		BagnonMsg(BAGNON_UPDATED);
	end
end

function BagnonMain_RescaleAll()
	if(Bagnon) then
		BagnonCore_Reposition(Bagnon);
	end
	
	if(Banknon) then
		BagnonCore_Reposition(Banknon);
	end
end

--[[
	Taken from Blizzard's code
	Shows the normal bank frame
--]]

function BagnonMain_ShowBlizBank()
	BankFrameTitleText:SetText(UnitName("npc"));
	SetPortraitTexture(BankPortraitTexture,"npc");
	ShowUIPanel(BankFrame);
	if ( not BankFrame:IsVisible() ) then
		CloseBankFrame();
	end
	UpdateBagSlotStatus();
end

--[[
	Utility Functions
--]]

function BagnonMsg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg, 0, 0.7, 1);
end